ghc-lib-parser-9.12.2.20250421: The GHC API, decoupled from GHC versions

Safe Haskell | Ignore
Language | GHC2021

GHC.Utils.Fingerprint

Contents

- Re-exported from GHC.Fingerprint

Synopsis

- readHexFingerprint :: String -> Fingerprint
- fingerprintByteString :: ByteString -> Fingerprint
- data Fingerprint = Fingerprint !Word64 !Word64
- fingerprint0 :: Fingerprint
- fingerprintFingerprints :: [Fingerprint] -> Fingerprint
- fingerprintData :: Ptr Word8 -> Int -> IO Fingerprint
- fingerprintString :: String -> Fingerprint
- fingerprintStrings :: [String] -> Fingerprint
- getFileHash :: FilePath -> IO Fingerprint

# Documentation

readHexFingerprint :: String -> Fingerprint Source #

fingerprintByteString :: ByteString -> Fingerprint Source #

# Re-exported from GHC.Fingerprint

data Fingerprint Source #

Constructors

Fingerprint !Word64 !Word64 |

#### Instances

Instances details

Binary Fingerprint | Since: binary-0.7.6.0
Instance details Defined in Data.Binary.Class Methods put :: Fingerprint -> Put Source # get :: Get Fingerprint Source # putList :: [Fingerprint] -> Put Source #
NFData Fingerprint | Since: deepseq-1.4.0.0
Instance details Defined in Control.DeepSeq Methods rnf :: Fingerprint -> () Source #
Storable Fingerprint | Since: base-4.4.0.0

Instance details

Defined in GHC.Internal.Foreign.Storable

Methods

sizeOf :: Fingerprint -> Int Source #

alignment :: Fingerprint -> Int Source #

peekElemOff :: Ptr Fingerprint -> Int -> IO Fingerprint Source #

pokeElemOff :: Ptr Fingerprint -> Int -> Fingerprint -> IO () Source #

peekByteOff :: Ptr b -> Int -> IO Fingerprint Source #

pokeByteOff :: Ptr b -> Int -> Fingerprint -> IO () Source #

peek :: Ptr Fingerprint -> IO Fingerprint Source #

poke :: Ptr Fingerprint -> Fingerprint -> IO () Source #

Generic Fingerprint |

Instance details

Defined in GHC.Internal.Generics

Associated Types

type Rep Fingerprint | Since: base-4.15.0.0

Instance details

Defined in GHC.Internal.Generics

type Rep Fingerprint = D1 ('MetaData "Fingerprint" "GHC.Internal.Fingerprint.Type" "ghc-internal" 'False) (C1 ('MetaCons "Fingerprint" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'SourceUnpack 'SourceStrict 'DecidedUnpack) (Rec0 Word64) :*: S1 ('MetaSel ('Nothing :: Maybe Symbol) 'SourceUnpack 'SourceStrict 'DecidedUnpack) (Rec0 Word64)))

Methods

from :: Fingerprint -> Rep Fingerprint x Source #

to :: Rep Fingerprint x -> Fingerprint Source #

Show Fingerprint | Since: base-4.7.0.0
Instance details Defined in GHC.Internal.Fingerprint.Type Methods showsPrec :: Int -> Fingerprint -> ShowS Source # show :: Fingerprint -> String Source # showList :: [Fingerprint] -> ShowS Source #
Binary Fingerprint Source # |
Instance details Defined in GHC.Utils.Binary Methods put_ :: WriteBinHandle -> Fingerprint -> IO () Source # put :: WriteBinHandle -> Fingerprint -> IO (Bin Fingerprint) Source # get :: ReadBinHandle -> IO Fingerprint Source #
Outputable Fingerprint Source # |
Instance details Defined in GHC.Utils.Outputable Methods ppr :: Fingerprint -> SDoc Source #
Eq Fingerprint | Since: base-4.4.0.0
Instance details Defined in GHC.Internal.Fingerprint.Type Methods (==) :: Fingerprint -> Fingerprint -> Bool Source # (/=) :: Fingerprint -> Fingerprint -> Bool Source #
Ord Fingerprint | Since: base-4.4.0.0

Instance details

Defined in GHC.Internal.Fingerprint.Type

Methods

compare :: Fingerprint -> Fingerprint -> Ordering Source #

(<) :: Fingerprint -> Fingerprint -> Bool Source #

(<=) :: Fingerprint -> Fingerprint -> Bool Source #

(>) :: Fingerprint -> Fingerprint -> Bool Source #

(>=) :: Fingerprint -> Fingerprint -> Bool Source #

max :: Fingerprint -> Fingerprint -> Fingerprint Source #

min :: Fingerprint -> Fingerprint -> Fingerprint Source #

type Rep Fingerprint | Since: base-4.15.0.0

Instance details

Defined in GHC.Internal.Generics

type Rep Fingerprint = D1 ('MetaData "Fingerprint" "GHC.Internal.Fingerprint.Type" "ghc-internal" 'False) (C1 ('MetaCons "Fingerprint" 'PrefixI 'False) (S1 ('MetaSel ('Nothing :: Maybe Symbol) 'SourceUnpack 'SourceStrict 'DecidedUnpack) (Rec0 Word64) :*: S1 ('MetaSel ('Nothing :: Maybe Symbol) 'SourceUnpack 'SourceStrict 'DecidedUnpack) (Rec0 Word64)))

fingerprint0 :: Fingerprint Source #

fingerprintFingerprints :: [Fingerprint] -> Fingerprint Source #

fingerprintData :: Ptr Word8 -> Int -> IO Fingerprint Source #

fingerprintString :: String -> Fingerprint Source #

fingerprintStrings :: [String] -> Fingerprint Source #

getFileHash :: FilePath -> IO Fingerprint Source #

Computes the hash of a given file. This function loops over the handle, running in constant memory.

Since: base-4.7.0.0